package net.csn.dr2d;

import javax.json.JsonObject;

/**
 * All you need about competitor relative to position, orientation, capacity, etc...
 */
public class Competitor {
	
	/**
	 * Un identifiant court ["01".."08"] 
	 */
    public String shortId;
    /**
     * La position sur le plateau [{1,1}..{12,12}]
     */
    Position locXY;
    /**
     * Son orientation [North, East, South, West]
     */
    Windrose facingTo;
    /**
     * L'energie disponible (Points PC) [0..7]
     */
    int energy;
    
    public Competitor(){
    	this("00",0,0,Windrose.None, 7);
    }
    public Competitor(final String shortId, final int locX, final int locY, final Windrose facingTo, final int energy){
    	this.shortId = shortId;
    	this.locXY = new Position(locX, locY);
    	this.facingTo = facingTo;
    	this.energy = energy;
    }
    
    /**
     * 
     * @param joData	{"mcndId":"01","mcndLocX":2,"mcndLocY":1,"azimuth":"West","energy":7}
     */
    public Competitor(final JsonObject joData){
    	this.shortId = joData.getString("mcndId","");
    	this.locXY = new Position(joData.getInt("mcndLocX", 0), joData.getInt("mcndLocY", 0));
    	this.facingTo = Windrose.fromName(joData.getString("azimuth", "None"));
    	this.energy = joData.getInt("energy", 7);
    }
    //
    
}
