package net.csn.dr2d;

/**
 * Specify a position to identify an area on the board game's surface.
 *  
 */
public class Position{
	public int x;
	public int y;
	public Position(){x=0;y=0;}
	public Position(final int x, final int y){this.x=x; this.y=y;}
	public Position(final Position posXY){this.x = posXY.x; this.y=posXY.y;}
	
	/**
	 * Instanciate a position from a linear value.
	 * 
	 * @param arrayStep
	 * @param linearPosition
	 * @return a position computed from linear value
	 */
	public static Position fromLinear(final int arrayStep, final int linearPosition)
	{
		final int y = Math.floorDiv(linearPosition,arrayStep);
		final int x = linearPosition % y;
		return new Position(x,y);
	}

//	/**
//	 * 
//	 * @return the linear position of the current Location
//	 */
//	public int toLinear(final int arrayStep)
//	{
//		return this.x + this.y*arrayStep;
//	}
	
}
