package net.csn.dr2d;

import java.io.StringReader;

import javax.json.Json;
import javax.json.JsonObject;

public class StgyBulk {
	static final String STGY_CALL 		= "stgyCall";
	static final String STGY_REPLY 		= "stgyReply";
	static final String STGYKEY_SEQ		= "seq";
	static final String STGYKEY_TOKEN	= "token";
	static final String STGYKEY_ARGSIN	= "argsIn";
	static final String STGYKEY_ARGSREF	= "argsRef";

	public static StgyBulk parseFromJSon(final String jsonDataString){
		StgyBulk stgyBulk = null;
		
    	JsonObject jsonData = Json.createReader(new StringReader(jsonDataString)).readObject();
    	
    	if(jsonData.containsKey(STGY_CALL)){   		// create StgyCall
    		jsonData = jsonData.getJsonObject(STGY_CALL);
    		stgyBulk = new StgyCall(jsonData);
    	}else if(jsonData.containsKey(STGY_REPLY)){ // create StgyReply
    		jsonData = jsonData.getJsonObject(STGY_REPLY);
    		stgyBulk = new StgyReply(jsonData);
    	}

		return stgyBulk;
	}

	StgyBulk(final JsonObject jsonData){
    	if(jsonData!=null){
			if(jsonData.containsKey(STGYKEY_SEQ)){
				final String valueSeq = jsonData.getString(STGYKEY_SEQ);
				_SeqType = SeqType.fromValue(valueSeq);
			}
			if(jsonData.containsKey(STGYKEY_TOKEN)){
				final String valueToken = jsonData.getString(STGYKEY_TOKEN);
				try{
					_Token = Long.parseLong(valueToken, 10);
				}catch(java.lang.NumberFormatException ex){_Token = 0L;}
			}
			if(jsonData.containsKey(STGYKEY_ARGSIN)&& !jsonData.isNull(STGYKEY_ARGSIN)){
				_ArgsIn = jsonData.getJsonObject(STGYKEY_ARGSIN);
			} else _ArgsIn = null;
			if(jsonData.containsKey(STGYKEY_ARGSREF) && !jsonData.isNull(STGYKEY_ARGSREF)){
				_ArgsRef = jsonData.getJsonObject(STGYKEY_ARGSREF);
			} else _ArgsRef = null;
    	}
	}
	
	public JsonObject toJSonObject() {return null;}

	public String toJSonString(){
		final JsonObject json = toJSonObject();
		return (json==null) ? null : json.toString();
	}

	/**
	 * Pour être valide, la structure doit comporter un type valide et un jeton valide.
	 * @return true when valid.
	 */
	public boolean isValid(){
		return (_SeqType!=null) && (_Token!=0L);
	}
	
	SeqType _SeqType;
	public final SeqType getSequence() { return _SeqType; }
	protected final void setSequence(final SeqType value) { _SeqType = value; }

	long _Token;
	public final long getToken() { return _Token; }
	protected final void setToken(final long value) { _Token = value; }

	JsonObject _ArgsIn;
	public final JsonObject getJSonArgsIn() { return _ArgsIn; }
	public final void setJSonArgsIn(final JsonObject value) { _ArgsIn = value; }

	JsonObject _ArgsRef;
	public final JsonObject getJSonArgsRef() { return _ArgsRef; }
	public final void setJSonArgsRef(final JsonObject value) { _ArgsRef = value; }

}
