package net.csn.dr2d;

public enum TileType {
    aucun           ( 0xFFFF ),
    neutre          ( 0x0000 ),
					
    conv_eNsS		( 0x0014 ),
    conv_eEsO		( 0x0028 ),
    conv_eSsN		( 0x0041 ),
    conv_eOsE		( 0x0082 ),
					
    conv_eNOsE		( 0x0092 ),
					
	conv_eOsS		( 0x0084 ),
    conv_eOsN		( 0x0081 ),
    conv_eSsO		( 0x0048 ),
    conv_eSsE		( 0x0042 ),
    conv_eEsN		( 0x0021 ),
    conv_eEsS		( 0x0024 ),
	conv_eNsE		( 0x0012 ),   
	conv_eNsO		( 0x0018 ),   
					
    pt_babord		( 0x00F0 ),
    pt_tribord		( 0x000F ),
				
    mur_N			( 0x0110 ),
    mur_E			( 0x0120 ),
    mur_S			( 0x0140 ),
    mur_O			( 0x0180 ),
    mur_NE			( 0x0130 ),
    mur_NO			( 0x0190 ),
    mur_SE			( 0x0160 ),
    mur_SO			( 0x01C0 ),
				
    mur_NS			( 0x0150 ),
    mur_EO			( 0x01A0 ),
					
    mur_NEO			( 0x01B0 ),
    mur_NES			( 0x0170 ),
    mur_NSO			( 0x01D0 ),
    mur_ESO			( 0x01E0 ),
	 			
    mur_NESO		( 0x01F0 ),
					
    murLaser_NS		( 0x0214 ),
    murLaser_EO		( 0x0228 ),
    murLaser_SN		( 0x0241 ),
    murLaser_OE		( 0x0282 ),
					
    pous_babord		( 0x0428 ), // pousseur E => O
    pous_poupe		( 0x0414 ), // pousseur N => S
    pous_proue		( 0x0441 ), // S => N
    pous_tribord	( 0x0482 ),
					
    action			( 0x0800 ),
					
    nid2poule		( 0x1001 ),
    presse			( 0x1002 ),
					
    clef_1rep		( 0x2001 ),
    clef_2rep		( 0x2002 ),
				
	loi_r1			( 0x8001 ),
    loi_r2			( 0x8010 ),
    loi_r3			( 0x8100 )
    ;
	int _type;
	TileType(final int type){
		_type = type;
	}
	public int getValue(){return _type;}
	public static TileType fromDecValue(final int val){
		for(TileType v : values()){
			if(v.getValue()==val) return v;
		}
		return null;
	}
	public static TileType fromHexValue(final String hexVal){ // "0x0000"
		try{
			int val = Integer.decode(hexVal);
			for(TileType v : values()){
				if(v.getValue()==val) return v;
			}
		}catch(NumberFormatException nfe){
			java.lang.System.out.println(nfe);
		}

		return null;
	}
}
