package net.csn.dr2d.wscp;

import java.awt.Color;

import javax.json.Json;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

public class CnslPlayerArgs_InitPlayerFeatures {
	public final String mcndId;
	public String pseudo;
	public Color argbBackColor;
	
	/**
	 * 
	 * @param argsIn,  {"mcndId":"01"}
	 * @param argsRef, {"avatar":{"pseudo":"Mécanoïd #1","argbBackColor":{"A":"FF","R":"7C","G":"FC","B":"00"}}}
	 * 
	 */
	public CnslPlayerArgs_InitPlayerFeatures(final JsonObject argsIn, final JsonObject argsRef){
		this.mcndId = argsIn.getString("mcndId",null);
		
		final JsonObject avatar = argsRef.getJsonObject("avatar");
		this.pseudo = avatar.getString("pseudo", null);
		final JsonObject argbBackColor = avatar.getJsonObject("argbBackColor");
		this.argbBackColor = new Color( 
				Integer.valueOf( argbBackColor.getString("R"), 16 ), // red
	            Integer.valueOf( argbBackColor.getString("G"), 16 ), // green
	            Integer.valueOf( argbBackColor.getString("B"), 16 ), // blue
	            Integer.valueOf( argbBackColor.getString("A"), 16 )  // alpha
				);
		}
	
	public JsonObject toJsonObject(){
		JsonObjectBuilder job = Json.createObjectBuilder();
		job.add("avatar", Json.createObjectBuilder()
			.add("pseudo", (this.pseudo==null)?"":this.pseudo)
			.add("argbBackColor", Json.createObjectBuilder()
					.add("A", String.format("%02X", this.argbBackColor.getAlpha())) 
					.add("R", String.format("%02X", this.argbBackColor.getRed()))
					.add("G", String.format("%02X", this.argbBackColor.getGreen()))
					.add("B", String.format("%02X", this.argbBackColor.getBlue()))
					));
		return job.build();
	}
}
