package net.csn.dr2d.wscp;

import java.util.ArrayList;

import javax.json.Json;
import javax.json.JsonArray;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

import net.csn.dr2d.Position;
import net.csn.dr2d.Windrose;

public class CnslPlayerArgs_InitPlayerLocalization {
	public final ArrayList<Integer> availableTiles;
	public Position position;
	public Windrose azimuth;
	
	/**
	 * 
	 * @param argsIn	{"availableTiles":[0,4,5,...,59,62,63]}
	 * @param argsRef	{"locX":1,"locY":5,"azimuth":"South"}
	 */
	public CnslPlayerArgs_InitPlayerLocalization(final JsonObject argsIn, final JsonObject argsRef){
		availableTiles = new ArrayList<Integer>();
		final JsonArray jaAvailableTiles = argsIn.getJsonArray("availableTiles");
		for(int idx = 0; idx < jaAvailableTiles.size(); ++idx){ 
			availableTiles.add(jaAvailableTiles.getInt(idx)); 
		}
		final int posX = argsRef.getInt("locX", 0);
		final int posY = argsRef.getInt("locY", 0);
		this.position = new Position(posX, posY);
		this.azimuth = Windrose.fromName(argsRef.getString("azimuth", ""));
	}
	
	public JsonObject toJsonObject(){
		JsonObjectBuilder job = Json.createObjectBuilder()
				.add("locX", this.position.x)
				.add("locY", this.position.y)
				.add("azimuth", this.azimuth.toString())
				;
		return job.build();
	}
}
