package net.csn.dr2d.wscp;

import java.util.ArrayList;

import javax.json.Json;
import javax.json.JsonArray;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

import net.csn.dr2d.Competitor;
import net.csn.dr2d.Windrose;

public class CnslPlayerArgs_InitStatusOfCompetitors {

	public final ArrayList<Competitor> competitors;
	
	/**
	 * 
	 * @param argsIn	{"competitors":[{"mcndId":"01","mcndLocX":6,"mcndLocY":7,"azimuth":"West","energy":7},{"mcndId":"02","mcndLocX":5,"mcndLocY":2,"azimuth":"North","energy":7}]}
	 * @param argsRef	null
	 */
	public CnslPlayerArgs_InitStatusOfCompetitors(final JsonObject argsIn, final JsonObject argsRef){
		competitors = new ArrayList<Competitor>();
		final JsonArray jaCompetitors = argsIn.getJsonArray("competitors");
		for(int idx = 0; idx < jaCompetitors.size(); ++idx){ 
			JsonObject joCompetitor = jaCompetitors.getJsonObject(idx);
			competitors.add(new Competitor(
					joCompetitor.getString("mcndId", ""),
					joCompetitor.getInt("mcndLocX", 0),
					joCompetitor.getInt("mcndLocY", 0),
					Windrose.fromName(joCompetitor.getString("azimuth","none")),
					joCompetitor.getInt("energy", 7)
					)); 
		}
	}
	
	public JsonObject toJsonObject(){
		JsonObjectBuilder job = Json.createObjectBuilder();
		return job.build();
	}
}
