package net.csn.dr2d.wscp.annotations;

import java.awt.Color;
import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;


/**
 * Cette annotation doit être utilisée pour décorer la méthode Java<br/>
 * lors d'une requête d'initialisation des données du joueur.
 *
 * <p>La méthode doit comporter les paramètres suivants:-
 * <ul>
 * <li>{@link String} pseudo</li>
 * <li>{@link Color} argbBackColor</li>
 * </ul>
 *
 * <p>The parameters may appear in any order. See
 * {@link Endpoint#onClose}
 * for more details on how the session parameter may be used during method calls 
 * annotated with this annotation.
 *
 * @author llorenç.corbey
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD) 
public @interface InitPlayerFeatures {

}
